Enum ChartEquates Singular
   Chart_2D        = 1
   Chart_3D
   Chart_Symbols
   Chart_Line
   Chart_2Line
   Chart_3Line
   Chart_2Stack
   Chart_3Stack
   Chart_HiLo
   Chart_Pie
   Chart_2Pie
   Chart_3Pie
   Chart_Horz2D
   Chart_Horz2Stack
   Chart_Horz3Stack
   Chart_VertBarGroup
   Chart_HorzBarGroup

   Gradient_None                   = 1
   Gradient_DarkBottomToTop
   Gradient_LightCenterToDarkSide
   Gradient_ColorCentertoBlackSide
   Gradient_Background

   Symbol_Point = 1
   Symbol_Circle
   Symbol_Triangle
   Symbol_Square

   MainTitle_Left = 1
   MainTitle_Center
   MainTitle_Right

   YTitle_Top = 1
   YTitle_Center
   YTitle_Bottom

   XTitle_LeftInLine = 1
   XTitle_Left
   XTitle_Center
   XTitle_Right
   XTitle_RightInLine

   HiLo_Bar = 1
   HiLo_Beam
   HiLo_Dot

   Line_Solid = 0
   Line_Dash
   Line_Dot
   Line_DashDot
   Line_DashDotDot

   Label_Label = 1
   Label_Value
   Label_PerCent
   Label_AltXText
End Enum

Type ChartData
   v(3)        As Long
   rc(3)       As Rect
   pt(3)       As Point
   Visible(3)  As Long
   altColor(3) As Long

   RR          As Long  'temp values variables created for convenience
   GG          As Long
   BB          As Long
   FadedColor  As Long
   DarkFadedColor As Long
   BorderColor As Long

   selected(3) As Long
   altXText(3) As StringZ * 50
   Label(3)    As StringZ * 50
   arcEnd(3)   As Single
   arcStart(3) As Single
   unusedA(3)  As Long
   unusedB(3)  As Long
   unusedC(3)  As StringZ * 50
   unusedD(3)  As StringZ * 50

   unusedE As Long
   unusedF As Long
   unusedG As StringZ * 50
   unusedH As StringZ * 50
End Type

Type ChartPolyPoints
   Count As Long
   x1 As Single
   y1 As Single
   x2 As Single
   y2 As Single
   x3 As Single
   y3 As Single
   x4 As Single
   y4 As Single
   x5 As Single
   y5 As Single
   x6 As Single
   y6 As Single
End Type

Type ChartSettings
   hParent        As Dword
   cID            As Long
   hGraphic       As Dword
   hGraphicDC     As Dword
   hBGImage       As Dword
   LM             As Long
   RM             As Long
   TM             As Long
   BM             As Long
   Title          As StringZ * 100
   XTitle         As StringZ * 100
   YTitle         As StringZ * 100
   MainTitleLoc   As Long
   XTitleLoc      As Long
   YTitleLoc      As Long
   DivYCount      As Long
   XMax           As Long
   XMin           As Long
   maxYvalue      As Long
   usefixedYvalue As Long
   fixedYValue    As Long
   coverage       As Single
   Pivot          As Long
   FadeValue      As Long
   AllBars        As Long
   ShowHGrid      As Long
   ShowVGrid      As Long
   ShowMainTitle  As Long
   DotGrid        As Long
   ShowMargins    As Long
   SpeedTest      As Long
   Instructions   As Long
   ShowAxisTitles As Long
   ShowAxisValues As Long
   UseAntiAliasing  As Long
   HoverTips      As Long

   DataSetTitle(3) As StringZ * 100

   UserData(3)   As StringZ * 5000
   altXText(3)   As StringZ * 5000
   Labels(3)  As StringZ * 5000
   BarColors(3)  As StringZ * 5000

   StampList     As StringZ * 5000   'approximately 16 stamps  x,y,filename:::x,y,filename:::   filename must be in \stamps

   GraphType     As Long
   BarGradientType  As Long  '1=flat  2=dark color bottom to color on top 3=lightcolor center, fade to color on each side 4=color center, fade to black on each side

   ThreeDX       As Long
   ThreeDY       As Long

   BezierTension As Single
   BezierDT      As Single

   PieRadius     As Long   'size of Pie radius
   PieCircle     As Long
   PieEject      As Long   'explode only selected section
   PieExplode    As Long   'explode all sections
   PieExplodeDistance As Long
   PieRotate     As Long   'use PieAngle
   PieAngle      As Single 'rotation of pie
   PieLegend     As Long   ' color with label/value
   PiePerCent    As Long   'show % inside pie
   PieDonut      As Long   'open center = 33% of radius
   PieDonutCaption(3) As StringZ * 100
   Pie3D         As Long
   Pie3DThickness As Long
   PieBeveled    As Long
   PieGradient   As Long
   PieGradientValue  As Long
   PieHideUnSelected As Long
   PieHighlightSelected As Long

   InstructFont     As Dword
   InstructFontName As StringZ * 100
   InstructFontSize As Dword
   InstructFontBold As Dword

   titleFont     As Dword
   titleFontName As StringZ * 100
   titleFontSize As Long
   titleFontBold As Long

   axisTitleFont As Dword
   axisTitleFontR As Dword
   axisTitleFontName As StringZ * 100
   axisTitleFontSize As Long
   axisTitleFontBold As Long

   axisValueFont As Dword
   axisValueFontR As Dword
   axisValueFontName As StringZ * 100
   axisValueFontSize As Long
   axisValueFontBold As Long

   LabelFont     As Dword
   LabelFontR    As Dword
   LabelFontName As StringZ * 100
   LabelFontSize As Long
   LabelFontBold As Long

   useAltColors  As Long
   usealtXText    As Long
   gradientBG    As Long
   fadeBG        As Long
   colorUnder    As Long

   cGrid         As Long
   cBG           As Long
   cTitle        As Long
   cAxisLines    As Long
   cAxisValues   As Long
   cPreBars(3)   As Long
   cPostBars(3)  As Long
   cSymbols(3)   As Long

   BarBorder     As Long
   ShowBarLabel  As Long
   Annotation    As Long
   ShowDataSetTitles As Long
   VertBarLabels As Long
   RoundedBar    As Long
   RoundValue    As Long
   MinusYAxis    As Long
   VertYTitle    As Long
   AutoXCount    As Long
   ExportFormat  As Long
   Equation(3)   As StringZ * 100
   EquationAnimate As Long
   Stamp         As StringZ * 256
   LargeStamp    As Long
   ShowBGImage   As Long
   BGImage       As StringZ * 256
   BGImageFit    As Long
   LineSymbol    As Long
   HiLoSymbol    As Long
   LineThickness As Long
   SymbolSize    As Long
   Interval      As Long
   DataSet       As Long

   GridOnTop     As Long
   SmoothLines   As Long
   LineStyle     As Long
   LabelType     As Long

   unusedA As Long
   unusedB As Long
   unusedC As Long
   unusedD As Long
   unusedE As Long

   unusedF As StringZ * 100
   unusedG As StringZ * 100
   unusedH As StringZ * 256
   unusedI As StringZ * 256
   unusedJ As StringZ * 5000

End Type

Sub DrawChart(BCD() As ChartData, BC As ChartSettings, EraseChart As Long)       'DataSet = 1,2,3 which is v, v2, v3 from data TYPE
   Local i,j,iDataSet,x1,iSymbol,bgW,bgH,txtW, txtH, gW, gH, BarWidth, BarCount,MaxXTextWidth As Long, temp$, oldrc,oldrc2,oldrc3, rc As Rect
   Local tW, tH, iStep, iCount, DivYValue As Long, iColor As Long
   Local tempBCLM, tempBCTM, tempBCRM, tempBCBM As Long
   Local qFreq, qStart, qStop As Quad
   Dim DataTotal(3) As Long

   'Call
   Select Case BC.GraphType
      Case %Chart_Pie
         DrawPieChart(BCD(), BC,1,1,1,BC.DataSet,1) : Exit Sub
      Case %Chart_2Pie
         DrawPieChart(BCD(), BC,1,2,1,1,0)
         DrawPieChart(BCD(), BC,2,2,0,2,1) : Exit Sub
      Case %Chart_3Pie
         DrawPieChart(BCD(), BC,1,3,1,1,0)
         DrawPieChart(BCD(), BC,2,3,0,2,0)
         DrawPieChart(BCD(), BC,3,3,0,3,1) : Exit Sub
   End Select

   If BC.SpeedTest Then QueryPerformanceFrequency qFreq : QueryPerformanceCounter qStart

   'Clear the Graphic control
   Graphic Attach BC.hGraphic, 0, ReDraw
   If EraseChart Then Graphic Clear BC.cBG
   Graphic Get Client To gW,gH
   Graphic Width 1
   Graphic Set Overlap

   'Draw Background - gradient or image
   If BC.ShowBGImage Then
      If BC.BGImageFit Then
         Graphic Attach BC.hBGImage, 0
         Graphic Get Canvas To bgW, bgH
         Graphic Attach BC.hGraphic, 0, ReDraw
         Graphic Stretch BC.hBGImage, 0, (0,0)-(bgW-1,bgH-1) To (0,0)-(gW-1,gH-1), %Mix_CopySrc, %HalfTone
      Else
         Graphic Copy BC.hBGImage, 0
      End If
   ElseIf BC.GradientBG Then
      Graphic Get Canvas To rc.nRight,rc.nBottom
      i = BC.BarGradientType
      BC.BarGradientType = %Gradient_Background
      DrawOneBar BCD(), rc, BC, BC.cBG, 0, oldRC
      BC.BarGradientType = i
   End If

   'Determine maximum Y value in DataSet
   BC.maxYvalue = 0
   Select Case BC.GraphType
      Case %Chart_2D,%Chart_3D,%Chart_Symbols,%Chart_Line
         For i = BC.Xmin To BC.XMax
            BC.maxYvalue = Max(BC.maxYvalue,BCD(i).v(BC.DataSet))
         Next i
      Case %Chart_2Line
         For i = BC.Xmin To BC.XMax
            BC.maxYvalue = Max(BC.maxYvalue,BCD(i).v(1))
            BC.maxYvalue = Max(BC.maxYvalue,BCD(i).v(2))
         Next i
      Case %Chart_3Line, %Chart_HiLo
         For i = BC.Xmin To BC.XMax
            BC.maxYvalue = Max(BC.maxYvalue,BCD(i).v(1))
            BC.maxYvalue = Max(BC.maxYvalue,BCD(i).v(2))
            BC.maxYvalue = Max(BC.maxYvalue,BCD(i).v(3))
         Next i
      Case %Chart_2Stack
         For i = BC.Xmin To BC.XMax
            BC.maxYvalue = Max(BC.maxYvalue,BCD(i).v(1)+BCD(i).v(2))
         Next i
      Case %Chart_3Stack
         For i = BC.Xmin To BC.XMax
            BC.maxYvalue = Max(BC.maxYvalue,BCD(i).v(1)+BCD(i).v(2)+BCD(i).v(3))
         Next i
   End Select
   'Round up actual max value or use fixed setting
   If BC.UseFixedYValue Then
      BC.MaxYValue = BC.FixedYValue
   Else
      Select Case BC.MaxYValue
         Case <= 10       : BC.MaxYValue = 10
         Case <= 25       : BC.MaxYValue = 25
         Case <= 50       : BC.MaxYValue = 50
         Case <= 75       : BC.MaxYValue = 75
         Case <= 100      : BC.MaxYValue = 100
         Case <= 250      : BC.MaxYValue = 250
         Case <= 500      : BC.MaxYValue = 500
         Case <= 750      : BC.MaxYValue = 750
         Case <= 1000     : BC.MaxYValue = 1000
         Case <= 2500     : BC.MaxYValue = 2500
         Case <= 5000     : BC.MaxYValue = 5000
         Case <= 7500     : BC.MaxYValue = 7500
         Case <= 10000    : BC.MaxYValue = 10000
         Case <= 25000    : BC.MaxYValue = 25000
         Case <= 50000    : BC.MaxYValue = 50000
         Case <= 75000    : BC.MaxYValue = 75000
         Case <= 100000   : BC.MaxYValue = 100000
         Case <= 250000   : BC.MaxYValue = 250000
         Case <= 500000   : BC.MaxYValue = 500000
         Case <= 750000   : BC.MaxYValue = 750000
         Case <= 1000000  : BC.MaxYValue = 1000000
         Case <= 2500000  : BC.MaxYValue = 2500000
         Case <= 5000000  : BC.MaxYValue = 5000000
         Case <= 7500000  : BC.MaxYValue = 7500000
         Case <= 10000000 : BC.MaxYValue = 10000000
      End Select
   End If

   'Adjust Margins so the Titles will fit
   tempBCLM = BC.LM : tempBCRM = BC.RM : tempBCTM = BC.TM : tempBCBM = BC.BM
   If BC.ShowAxisTitles Then
      Select Case BC.XTitleLoc
         Case %XTitle_Left, %XTitle_Center, %XTitle_Right
            Graphic Set Font BC.axisValueFont
            Graphic Text Size "88" To i,j
            Graphic Set Font BC.axisTitleFont
            Graphic Text Size BC.XTitle To txtW, txtH
            BC.BM = Max(BC.BM, 10 + j + txtH)
         Case %XTitle_RightInline
            Graphic Set Font BC.axisTitleFont
            Graphic Text Size BC.XTitle To txtW, txtH
            BC.RM = Max(BC.RM, 40 + txtW)
         Case %XTitle_LeftInline
            Graphic Set Font BC.axisTitleFont
            Graphic Text Size BC.XTitle To txtW, txtH
            BC.LM = Max(BC.LM, 40 + txtW)
      End Select

      If BC.VertYTitle Then
         Graphic Set Font BC.axisTitleFontR
         Graphic Text Size BC.YTitle To txtW, txtH
         BC.LM = Max(BC.LM, 40 + txtH + Graphic(Text.Size.Y,Str$(BC.MaxYValue)))
      Else
         Graphic Set Font BC.axisTitleFont
         Graphic Text Size BC.YTitle To txtW, txtH
         BC.LM = Max(BC.LM, 40 + txtW + Graphic(Text.Size.X,Str$(BC.MaxYValue)))
      End If

      If BC.ShowDataSetTitles Then
            Graphic Set Font BC.axisTitleFont
            Graphic Text Size BC.DataSetTitle(1) To txtW, txtH
            BC.RM = Max(BC.RM, 40 + txtW)
            Graphic Text Size BC.DataSetTitle(2) To txtW, txtH
            BC.RM = Max(BC.RM, 40 + txtW)
            Graphic Text Size BC.DataSetTitle(3) To txtW, txtH
            BC.RM = Max(BC.RM, 40 + txtW)
      End If

   End If

   'Draw Axis Lines
   Graphic Color BC.cAxisLines, BC.cAxisLines
   If BC.MinusYAxis Then
      Graphic Line (BC.LM,BC.TM-5)-(BC.LM,gH-10), BC.cGrid    'both vertical axis
   Else
      Graphic Line (BC.LM,gH-BC.BM)-(BC.LM,BC.TM-5), BC.cGrid  'vertical axis
   End If
   Graphic Line (BC.LM,gH-BC.BM)-(gW-BC.RM,gH-BC.BM), BC.cGrid 'horizontal axis

   'Draw Instructions
   If BC.Instructions Then
      Graphic Set Font BC.InstructFont
      Graphic Width 1
      Graphic Style 2
      Graphic Color BC.cTitle, -2  'BC.cBG
      Graphic Box (0,0)-(20,20),,%Red, -2         'top left
      Graphic Box (gW-1,0)-(gW-21,20),,%Red, -2     'top right
      Graphic Box (0,gH-1)-(20,gH-21),,%Red, -2     'bottom left
      Graphic Box (gW-1,gH-1)-(gW-21,gH-21),,%Red, -2 'bottom right
      Graphic Style 0
      Graphic Width BC.LineThickness

      Graphic Set Font BC.axisValueFont
'      Graphic Color BC.cTitle, -2  'BC.cBG
      'upper left
      Graphic Set Pos (25,10) : Graphic Print "Clk - Erase last symbol, DblClk - Erase all"
      'upper right
      temp$ = "DblClk - Remove Selections"
      Graphic Set Pos (gW - 25 - Graphic(Text.Size.X,temp$),10) : Graphic Print temp$
      'lower left
      Graphic Set Pos (25, gH - 2*Graphic(Text.Size.X,"C")) : Graphic Print "DblClk - Settings Dialog Repositioned"
      'lower right
      Graphic Set Pos (gW - 25 - Graphic(Text.Size.X,"DblClk - Settings"), gH - 2*Graphic(Text.Size.X,"C")) : Graphic Print "DblClk - Settings"
      'midleft
      Graphic Set Pos (10, gH/2 - 30)                              : Graphic Print "DblClk - Stamp"
      Graphic Set Pos (10, gH/2 - 30 + Graphic(Text.Size.Y,"C"))   : Graphic Print "RClick Bar - Select"
      Graphic Set Pos (10, gH/2 - 30 + 2*Graphic(Text.Size.Y,"C")) : Graphic Print "RClick - Settings"
   End If

   'Draw Top Title
   If BC.ShowMainTitle Then
      Graphic Color BC.cTitle, -2  'BC.cBG
      Graphic Set Font BC.titleFont
      BC.TM = Graphic(Text.Size.Y,BC.Title) * 2
      Graphic Text Size BC.Title To txtW, txtH
      Select Case BC.MainTitleLoc
         Case %MainTitle_Left   : Graphic Set Pos (BC.LM,BC.TM-1.5*txtH)
         Case %MainTitle_Center : Graphic Set Pos (BC.LM + (gW-BC.LM-BC.RM-txtW)/2, BC.TM - 1.5*txtH)
         Case %MainTitle_Right  : Graphic Set Pos (gW - BC.RM - txtW, BC.TM - 1.5*txtH)
      End Select
      Graphic Print BC.Title
   End If

   'Show Margins
   If BC.ShowMargins Then
      Graphic Color %Red
      Graphic Style 2
      Graphic Line (BC.LM,0)-(BC.LM,gH)
      Graphic Line (0,BC.TM)-(gW,BC.TM)
      Graphic Line (gW-BC.RM,0)-(gW-BC.RM,gH)
      Graphic Line (0,gH-BC.BM)-(gW,gH-BC.BM)
      Graphic Style 0
   End If

   'Draw X Axis Title
   If BC.ShowAxisTitles Then
      Graphic Set Font BC.axisValueFont
      Graphic Text Size "99" To i,j
      Graphic Color BC.cTitle, -2  'BC.cBG
      Graphic Set Font BC.axisTitleFont
      Graphic Text Size BC.XTitle To txtW, txtH
      Select Case BC.XTitleLoc
         Case %XTitle_LeftInline   : Graphic Set Pos (BC.LM-txtW-20,                   gH-BC.BM+10)
         Case %XTitle_Left         : Graphic Set Pos (BC.LM,                           gH-BC.BM+10+j)
         Case %XTitle_Center       : Graphic Set Pos (BC.LM + (gW-BC.LM-BC.RM-txtW)/2, gH-BC.BM+10+j)
         Case %XTitle_Right        : Graphic Set Pos (gW-BC.RM-txtW,                   gH-BC.BM+10+j)
         Case %XTitle_RightInLine  : Graphic Set Pos (gW-BC.RM+10,                     gH-BC.BM+10)
      End Select
      Graphic Print BC.XTitle
   End If

   'Draw Horizontal Grid
   If BC.GridOnTop = 0 Then
      For i = 1 To BC.DivYCount
         If BC.ShowHGrid And BC.DotGrid Then Graphic Style 2
         Graphic Line (BC.LM-2 ,gH-BC.BM-i*(gH-BC.TM-BC.BM) / BC.DivYCount) -(IIf(BC.ShowHGrid,gW-BC.RM,BC.LM+2),gH-BC.BM-i*(gH-BC.TM-BC.BM) / BC.DivYCount), BC.cGrid
         Graphic Style 0
      Next i
   End If

   'Draw Y Axis Values
   Graphic Set Font BC.axisValueFont
   Graphic Color BC.cAxisValues, -2
   DivYValue = BC.maxYValue/BC.DivYCount
   For i = 1 To BC.DivYCount
      temp$ = Format$(i * DivYValue, "##,###,##0")
      Graphic Set Pos (BC.LM - Graphic(Text.Size.X, temp$) - 5,gH-BC.BM-i*(gH-BC.TM-BC.BM) / BC.DivYCount-Graphic(Text.Size.Y,temp$)/2)
      Graphic Print temp$
   Next i

   'Draw Y Axis Title
   If BC.ShowAxisTitles Then
      Graphic Color BC.cTitle, -2  'BC.cBG
      If BC.VertYTitle Then
         Graphic Set Font BC.axisTitleFontR
         Graphic Text Size BC.YTitle To txtW, txtH
         Select Case BC.YTitleLoc
            Case %YTitle_Top    : Graphic Set Pos  (BC.LM-txtH-Graphic(Text.Size.X,Str$(BC.MaxYValue)), BC.TM + txtW)
            Case %YTitle_Center : Graphic Set Pos  (BC.LM-txtH-Graphic(Text.Size.X,Str$(BC.MaxYValue)), BC.TM + (gH-BC.TM-BC.BM+txtW)/2)
            Case %YTitle_Bottom : Graphic Set Pos  (BC.LM-txtH-Graphic(Text.Size.X,Str$(BC.MaxYValue)), gH - BC.BM)
         End Select
      Else
         Graphic Set Font BC.axisTitleFont
         Graphic Text Size BC.YTitle To txtW, txtH
         Select Case BC.YTitleLoc
            Case %YTitle_Top    : Graphic Set Pos  (BC.LM-20-txtW-Graphic(Text.Size.X,Trim$(Str$(BC.MaxYValue))), BC.TM - txtH/2)
            Case %YTitle_Center : Graphic Set Pos  (BC.LM-20-txtW-Graphic(Text.Size.X,Trim$(Str$(BC.MaxYValue))), BC.TM + (gH-BC.TM-BC.BM-txtH)/2)
            Case %YTitle_Bottom : Graphic Set Pos  (BC.LM-20-txtW-Graphic(Text.Size.X,Trim$(Str$(BC.MaxYValue))), gH - BC.BM - txtH)
         End Select
      End If
      Graphic Print BC.YTitle
   End If

   'Initialize Bar Settings
   For i = 1 To UBound(BCD)
      Reset BCD(i).rc(1)      , BCD(i).rc(2)      , BCD(i).rc(3)
      Reset BCD(i).visible(1) , BCD(i).visible(2) , BCD(i).visible(3)
      DataTotal(1) += BCD(i).v(1)
      DataTotal(2) += BCD(i).v(2)
      DataTotal(3) += BCD(i).v(3)
   Next i   'reset all of the previous bar rectangles
   iStep = 1

   'get maximum width of X-data - take into account largest value and alt-Text)
   If BC.UsealtXText Then
      For i = BC.Xmin To BC.XMax
         MaxXTextWidth = Max(MaxXTextWidth, Graphic(Text.Size.X,BCD(i).altXText(BC.DataSet)))
         If BC.GraphType = %Chart_2D Or BC.GraphType = %Chart_2Line Then
            MaxXTextWidth = Max(MaxXTextWidth, Graphic(Text.Size.X,BCD(i).altXText(1)))
            MaxXTextWidth = Max(MaxXTextWidth, Graphic(Text.Size.X,BCD(i).altXText(2)))
         ElseIf BC.GraphType = %Chart_3D Or BC.GraphType = %Chart_3Line Or BC.GraphType = %Chart_HiLo Then
            MaxXTextWidth = Max(MaxXTextWidth, Graphic(Text.Size.X,BCD(i).altXText(1)))
            MaxXTextWidth = Max(MaxXTextWidth, Graphic(Text.Size.X,BCD(i).altXText(2)))
            MaxXTextWidth = Max(MaxXTextWidth, Graphic(Text.Size.X,BCD(i).altXText(3)))
         End If
      Next i
   Else
      MaxXTextWidth = Graphic(Text.Size.X,LTrim$(Str$(BC.XMax)))
   End If
   'take into account width of BarLabel
   If BC.ShowBarLabel Then
      For i = BC.Xmin To BC.XMax
         Select Case BC.LabelType
            Case %Label_Value    : temp$ = Format$(BCD(i).v(BC.DataSet), "###,###,##0")
            Case %Label_Label    : temp$ = BCD(i).label(BC.DataSet)
            Case %Label_PerCent  : temp$ = Format$(BCD(i).v(BC.DataSet) / DataTotal(BC.DataSet) * 100, "#0.0") + "%"
            Case %Label_AltXText : temp$ = BCD(i).altXText(BC.DataSet)
         End Select
         MaxXTextWidth = Max(MaxXTextWidth, Graphic(Text.Size.X,temp$))
         If BC.GraphType = %Chart_2D Or BC.GraphType = %Chart_2Line Then
            MaxXTextWidth = Max(MaxXTextWidth, Graphic(Text.Size.X,BCD(i).label(1)))
            MaxXTextWidth = Max(MaxXTextWidth, Graphic(Text.Size.X,BCD(i).label(2)))
         ElseIf BC.GraphType = %Chart_3D Or BC.GraphType = %Chart_3Line Or BC.GraphType = %Chart_HiLo Then
            MaxXTextWidth = Max(MaxXTextWidth, Graphic(Text.Size.X,BCD(i).label(1)))
            MaxXTextWidth = Max(MaxXTextWidth, Graphic(Text.Size.X,BCD(i).label(2)))
            MaxXTextWidth = Max(MaxXTextWidth, Graphic(Text.Size.X,BCD(i).label(3)))
         End If
      Next i
   End If

   'Set BarWidth so that largest X text will fit in it
   If BC.AutoXCount Then
      If BC.AllBars Then
         BarWidth = (gW-BC.LM-BC.RM)/(BC.Xmax-BC.Xmin+1)
         If iStep*BarWidth < 1.1* MaxXTextWidth Then iStep = 2
         If iStep*BarWidth < 1.1* MaxXTextWidth Then iStep = 3
         If iStep*BarWidth < 1.1* MaxXTextWidth Then iStep = 4
         If iStep*BarWidth < 1.1* MaxXTextWidth Then iStep = 5
         If iStep*BarWidth < 1.1* MaxXTextWidth Then iStep = 6
         If iStep*BarWidth < 1.1* MaxXTextWidth Then iStep = 7
      Else
         BarWidth = (gW-BC.LM-BC.RM)/(BC.Xmax-BC.Xmin+1)
         If BarWidth < 1.1* MaxXTextWidth Then iStep = 2 : BarWidth = 2 * (gW-BC.LM-BC.RM)/(BC.Xmax-BC.Xmin+1)
         If BarWidth < 1.1* MaxXTextWidth Then iStep = 3 : BarWidth = 3 * (gW-BC.LM-BC.RM)/(BC.Xmax-BC.Xmin+1)
         If BarWidth < 1.1* MaxXTextWidth Then iStep = 4 : BarWidth = 4 * (gW-BC.LM-BC.RM)/(BC.Xmax-BC.Xmin+1)
         If BarWidth < 1.1* MaxXTextWidth Then iStep = 5 : BarWidth = 5 * (gW-BC.LM-BC.RM)/(BC.Xmax-BC.Xmin+1)
         If BarWidth < 1.1* MaxXTextWidth Then iStep = 6 : BarWidth = 6 * (gW-BC.LM-BC.RM)/(BC.Xmax-BC.Xmin+1)
         If BarWidth < 1.1* MaxXTextWidth Then iStep = 7 : BarWidth = 7 * (gW-BC.LM-BC.RM)/(BC.Xmax-BC.Xmin+1)
      End If
   End If

   For i = BC.Xmin To BC.Xmax
      If BC.AllBars Or (BC.AllBars = 0 And i Mod iStep = 0) Then Incr BarCount : BCD(i).visible(BC.DataSet) = 1 Else BCD(i).Visible(BC.DataSet) = 0
   Next i
   BarWidth = BC.coverage * (gW-BC.LM-BC.RM) / BarCount

   'Set Bar dimensions and Draw the Bars
   iCount = 0 : Reset oldRC, oldRC2, oldRC3
   For i = BC.Xmin To BC.Xmax
      If BCD(i).visible(BC.DataSet) = 0 Then Iterate For
      BCD(i).rc(1).left    = BC.LM + iCount * (gW-BC.LM-BC.RM)/BarCount
      BCD(i).rc(1).bottom  = gH-BC.BM
      BCD(i).rc(1).right   = BCD(i).rc(1).left + BarWidth
      BCD(i).rc(1).top     = BCD(i).rc(1).bottom - (BCD(i).v(1) * (gH-BC.TM-BC.BM) / DivYValue) / BC.DivYCount
      BCD(i).pt(1).x       = (BCD(i).rc(1).Right + BCD(i).rc(1).Left)/2
      BCD(i).pt(1).y       = BCD(i).rc(1).Top

      BCD(i).rc(2).left    = BCD(i).rc(1).left
      BCD(i).rc(2).bottom  = BCD(i).rc(1).bottom
      BCD(i).rc(2).right   = BCD(i).rc(1).right
      BCD(i).rc(2).top     = BCD(i).rc(2).bottom - (BCD(i).v(2) * (gH-BC.TM-BC.BM) / DivYValue) / BC.DivYCount
      BCD(i).pt(2).x       = (BCD(i).rc(2).Right + BCD(i).rc(2).Left)/2
      BCD(i).pt(2).y       = BCD(i).rc(2).Top

      BCD(i).rc(3).left    = BCD(i).rc(1).left
      BCD(i).rc(3).bottom  = BCD(i).rc(1).bottom
      BCD(i).rc(3).right   = BCD(i).rc(1).right
      BCD(i).rc(3).top     = BCD(i).rc(3).bottom - (BCD(i).v(3) * (gH-BC.TM-BC.BM) / DivYValue) / BC.DivYCount
      BCD(i).pt(3).x       = (BCD(i).rc(3).Right + BCD(i).rc(3).Left)/2
      BCD(i).pt(3).y       = BCD(i).rc(3).Top

      'now draw the Vert Grid lines
      If BC.GridOnTop = 0 Then
         If BC.ShowVGrid And i Mod iStep = 0 Then
            If BC.ShowHGrid And BC.DotGrid Then Graphic Style 2
            x1 = (BCD(i).rc(BC.DataSet).left + BCD(i).rc(BC.DataSet).right ) / 2
            Graphic Line (x1, gH-BC.BM+2)-(x1,BC.TM-2), BC.cGrid
            Graphic Style 0
         End If
      End If
      'now Draw the bars
      If BC.GraphType = %Chart_2Stack Then      '2 stacked bars  v1 and v2
         iColor = IIf(i > BC.Pivot,BC.cPostBars(1), BC.cPreBars(1))
         iColor = IIf(BC.UseAltColors,BCD(i).altColor(1),iColor)
         rc = BCD(i).rc(1)
         DrawOneBar BCD(), rc, BC, iColor, BCD(i).selected(1), oldRC, %False
         oldRC = RC

         iColor = IIf(i > BC.Pivot,BC.cPostBars(2), BC.cPreBars(2))
         iColor = IIf(BC.UseAltColors,BCD(i).altColor(2),iColor)
         rc = BCD(i).rc(2)
         rc.nTop    += oldRC.Top - oldRC.Bottom
         rc.nBottom += oldRC.Top - oldRC.Bottom
         DrawOneBar BCD(), rc, BC, iColor, BCD(i).selected(2), oldRC2, %True
         oldRC2 = RC

      ElseIf BC.GraphType = %Chart_3Stack Then  '3 stacked bars  v1 and v2 and v2
         iColor = IIf(i > BC.Pivot,BC.cPostBars(1), BC.cPreBars(1))
         iColor = IIf(BC.UseAltColors,BCD(i).altColor(1),iColor)
         rc = BCD(i).rc(1)
         DrawOneBar BCD(), rc, BC, iColor, BCD(i).selected(1), oldRC, %False
         oldRC = RC

         iColor = IIf(i > BC.Pivot,BC.cPostBars(2), BC.cPreBars(2))
         iColor = IIf(BC.UseAltColors,BCD(i).altColor(2),iColor)
         rc = BCD(i).rc(2)
         rc.nTop    += oldRC.Top - oldRC.Bottom
         rc.nBottom += oldRC.Top - oldRC.Bottom
         DrawOneBar BCD(), rc, BC, iColor, BCD(i).selected(2), oldRC2, %False
         oldRC2 = RC

         iColor = IIf(i > BC.Pivot,BC.cPostBars(3), BC.cPreBars(3))
         iColor = IIf(BC.UseAltColors,BCD(i).altColor(3),iColor)
         rc = BCD(i).rc(3)
         rc.nTop    += oldRC.Top - oldRC.Bottom + oldRC2.top - oldRC2.bottom
         rc.nBottom += oldRC.Top - oldRC.Bottom + oldRC2.top - oldRC2.bottom
         DrawOneBar BCD(), rc, BC, iColor, BCD(i).selected(3), oldRC2, %True
         oldRC2 = RC

      ElseIf BC.GraphType = %Chart_2Line Then   '2 lines v1 and v2
         iDataSet = BC.DataSet : iSymbol = BC.LineSymbol
         BC.DataSet = 1 : BC.LineSymbol = %Symbol_Circle
         iColor = IIf(i > BC.Pivot,BC.cPostBars(1), BC.cPreBars(1))
         rc = BCD(i).rc(1)  : DrawOneBar BCD(), rc, BC, iColor, BCD(i).selected(1), oldRC  : oldRC  = RC
         BC.DataSet = 2 : BC.LineSymbol = %Symbol_Square
         iColor = IIf(i > BC.Pivot,BC.cPostBars(2), BC.cPreBars(2))
         rc = BCD(i).rc(2) : DrawOneBar BCD(), rc, BC, iColor, BCD(i).selected(2), oldRC2 : oldRC2 = RC
         BC.DataSet = iDataSet : BC.LineSymbol = iSymBol

      ElseIf BC.GraphType = %Chart_3Line Then   '3 lines v1 and v2 and v3
         iDataSet = BC.DataSet : iSymbol = BC.LineSymbol
         BC.DataSet = 1 : BC.LineSymbol = %Symbol_Circle
         iColor = IIf(i > BC.Pivot,BC.cPostBars(1), BC.cPreBars(1))
         rc = BCD(i).rc(1)  : DrawOneBar BCD(), rc, BC, iColor, BCD(i).selected(1), oldRC  : oldRC  = RC
         BC.DataSet = 2 : BC.LineSymbol = %Symbol_Square
         iColor = IIf(i > BC.Pivot,BC.cPostBars(2), BC.cPreBars(2))
         rc = BCD(i).rc(2) : DrawOneBar BCD(), rc, BC, iColor, BCD(i).selected(2), oldRC2 : oldRC2 = RC
         BC.DataSet = 3 : BC.LineSymbol = %Symbol_Triangle
         iColor = IIf(i > BC.Pivot,BC.cPostBars(3), BC.cPreBars(3))
         rc = BCD(i).rc(3) : DrawOneBar BCD(), rc, BC, iColor, BCD(i).selected(3), oldRC3 : oldRC3 = RC
         BC.DataSet = iDataSet : iSymbol = BC.LineSymbol

      ElseIf BC.GraphType = %Chart_HiLo Then
         iColor = IIf(i > BC.Pivot,BC.cPostBars(BC.DataSet), BC.cPreBars(BC.DataSet))
         iColor = IIf(BC.UseAltColors,BCD(i).altColor(3),iColor)
         rc.nTop  = BCD(i).rc(3).nTop  : rc.nBottom = BCD(i).rc(2).nTop
         rc.nLeft = BCD(i).rc(3).nLeft : rc.nRight  = BCD(i).rc(2).nRight
         DrawOneBar BCD(), rc, BC, iColor, BCD(i).selected(1), oldRC
         oldRC = RC

      Else
         iColor = IIf(i > BC.Pivot,BC.cPostBars(BC.DataSet), BC.cPreBars(BC.DataSet))
         iColor = IIf(BC.UseAltColors,BCD(i).altColor(BC.DataSet),iColor)
         rc = BCD(i).rc(BC.DataSet)
         'If BC.SmoothLines = 0 And BC.GraphType <> %Chart_Line Then DrawOneBar BCD(), rc, BC, iColor, BCD(i).selected(1), oldRC
         DrawOneBar BCD(), rc, BC, iColor, BCD(i).selected(1), oldRC
         oldRC = RC
      End If
      iCount += 1
   Next i

   'Ensure that smooth lines are behind the symbols
   If BC.SmoothLines And (BC.GraphType=%Chart_Line Or BC.GraphType=%Chart_2Line Or BC.GraphType=%Chart_3Line) Then
      Select Case BC.GraphType
         Case %Chart_Line
            DrawCurves BCD(), BC, BC.BezierDT, BC.BezierTension, BC.DataSet,BC.cPreBars(BC.DataSet)
         Case %Chart_2Line
            DrawCurves BCD(), BC, BC.BezierDT, BC.BezierTension, 1, BC.cPreBars(1)
            DrawCurves BCD(), BC, BC.BezierDT, BC.BezierTension, 2, BC.cPreBars(2)
         Case %Chart_3Line
            DrawCurves BCD(), BC, BC.BezierDT, BC.BezierTension, 1, BC.cPreBars(1)
            DrawCurves BCD(), BC, BC.BezierDT, BC.BezierTension, 2, BC.cPreBars(2)
            DrawCurves BCD(), BC, BC.BezierDT, BC.BezierTension, 3, BC.cPreBars(3)
      End Select
      For i = BC.XMin To BC.XMax
         iDataSet = BC.DataSet : iSymbol = BC.LineSymbol
         Select Case BC.GraphType
            Case %Chart_Line
               iColor = IIf(i > BC.Pivot,BC.cPostBars(BC.DataSet), BC.cPreBars(BC.DataSet))
               rc = BCD(i).rc(BC.DataSet) : oldRC = RC
               DrawOneBar BCD(), rc, BC, iColor, BCD(i).selected(1), oldRC
            Case %Chart_2Line
               iDataSet = BC.DataSet : iSymbol = BC.LineSymbol
               BC.DataSet = 1 : BC.LineSymbol = %Symbol_Circle
               iColor = IIf(i > BC.Pivot,BC.cPostBars(1), BC.cPreBars(1))
               rc = BCD(i).rc(1)  : DrawOneBar BCD(), rc, BC, iColor, BCD(i).selected(1), oldRC  : oldRC  = RC
               BC.DataSet = 2 : BC.LineSymbol = %Symbol_Square
               iColor = IIf(i > BC.Pivot,BC.cPostBars(2), BC.cPreBars(2))
               rc = BCD(i).rc(2) : DrawOneBar BCD(), rc, BC, iColor, BCD(i).selected(2), oldRC2 : oldRC2 = RC
               BC.DataSet = iDataSet : BC.LineSymbol = iSymBol
            Case %Chart_3Line
               BC.DataSet = 1 : BC.LineSymbol = %Symbol_Circle
               iColor = IIf(i > BC.Pivot,BC.cPostBars(1), BC.cPreBars(1))
               rc = BCD(i).rc(1)  : DrawOneBar BCD(), rc, BC, iColor, BCD(i).selected(1), oldRC  : oldRC  = RC
               BC.DataSet = 2 : BC.LineSymbol = %Symbol_Square
               iColor = IIf(i > BC.Pivot,BC.cPostBars(2), BC.cPreBars(2))
               rc = BCD(i).rc(2) : DrawOneBar BCD(), rc, BC, iColor, BCD(i).selected(2), oldRC2 : oldRC2 = RC
               BC.DataSet = 3 : BC.LineSymbol = %Symbol_Triangle
               iColor = IIf(i > BC.Pivot,BC.cPostBars(3), BC.cPreBars(3))
               rc = BCD(i).rc(3) : DrawOneBar BCD(), rc, BC, iColor, BCD(i).selected(3), oldRC3 : oldRC3 = RC
               BC.DataSet = iDataSet : iSymbol = BC.LineSymbol
         End Select
      Next i
   End If

   'Draw Horizontal Grid
   If BC.GridOnTop Then
      For i = 1 To BC.DivYCount
         If BC.ShowHGrid And BC.DotGrid Then Graphic Style 2
         Graphic Line (BC.LM-2 ,gH-BC.BM-i*(gH-BC.TM-BC.BM) / BC.DivYCount) -(IIf(BC.ShowHGrid,gW-BC.RM,BC.LM+2),gH-BC.BM-i*(gH-BC.TM-BC.BM) / BC.DivYCount), BC.cGrid
         Graphic Style 0
      Next i
   End If

   'Draw Vertical Grid
   If BC.GridOnTop Then
      For i = BC.Xmin To BC.XMax
         If BC.ShowVGrid And i Mod iStep = 0 Then
            If BC.ShowHGrid And BC.DotGrid Then Graphic Style 2
            x1 = (BCD(i).rc(BC.DataSet).left + BCD(i).rc(BC.DataSet).right ) / 2
            Graphic Line (x1, gH-BC.BM+2)-(x1,BC.TM-2), BC.cGrid
         End If
      Next i
   End If
   Graphic Style 0

   'Draw X Axis Values (values or alt-text) and Vertical Lines
   If BC.ShowAxisValues Then
      Graphic Color BC.cAxisValues, -2
      Graphic Set Font BC.axisValueFont
      Graphic Text Size LTrim$(Str$(BC.XMax)) To tW, tH
      For i = BC.Xmin To BC.Xmax
         If i Mod iStep Then Iterate For
         If BC.usealtXText Then
            Graphic Set Pos (BCD(i).rc(BC.DataSet).left+(BarWidth-Graphic(Text.Size.X,BCD(i).altXText(BC.DataSet)))/2,BCD(i).rc(BC.DataSet).bottom+10)
            Graphic Print BCD(i).altXText(BC.DataSet)
         Else
            Graphic Set Pos (BCD(i).rc(1).left+(BarWidth-Graphic(Text.Size.X,Trim$(Str$(i))))/2,BCD(i).rc(1).bottom+10)
            Graphic Print Format$(i,"#0")
         End If
      Next i
   End If

   'Draw Bar Labels
   If BC.ShowBarLabel Then
      Graphic Color BC.cAxisValues, -2
      Graphic Set Font IIf(BC.VertBarLabels, BC.LabelFontR, BC.LabelFont)
      For i = BC.XMin To BC.XMax
         If i Mod iStep Then Iterate For
         Select Case BC.GraphType
            Case %Chart_2Line
               temp$ = ThisLabel(BCD(), BC, i, 1, DataTotal(1))   'iPos  ThisDataSet
               Graphic Set Pos (BCD(i).rc(1).nLeft + (BarWidth-Graphic(Text.Size.X,temp$))/2, BCD(i).rc(1).Top - BC.SymbolSize - 1.5 * Graphic(Text.Size.Y,temp$))
               Graphic Print temp$
               temp$ = ThisLabel(BCD(), BC, i, 2, DataTotal(2))   'iPos  ThisDataSet
               Graphic Set Pos (BCD(i).rc(2).nLeft + (BarWidth-Graphic(Text.Size.X,temp$))/2, BCD(i).rc(2).Top - BC.SymbolSize - 1.5 * Graphic(Text.Size.Y,temp$))
               Graphic Print temp$
            Case %Chart_3Line
               temp$ = ThisLabel(BCD(), BC, i, 1, DataTotal(1))
               Graphic Set Pos (BCD(i).rc(1).nLeft + (BarWidth-Graphic(Text.Size.X,temp$))/2, BCD(i).rc(1).Top - BC.SymbolSize - 1.5 * Graphic(Text.Size.Y,temp$))
               Graphic Print temp$
               temp$ = ThisLabel(BCD(), BC, i, 2, DataTotal(2))
               Graphic Set Pos (BCD(i).rc(1).nLeft + (BarWidth-Graphic(Text.Size.X,temp$))/2, BCD(i).rc(2).Top - BC.SymbolSize - 1.5 * Graphic(Text.Size.Y,temp$))
               Graphic Print temp$
               temp$ = ThisLabel(BCD(), BC, i, 3, DataTotal(3))
               Graphic Set Pos (BCD(i).rc(1).nLeft + (BarWidth-Graphic(Text.Size.X,temp$))/2, BCD(i).rc(3).Top - BC.SymbolSize - 1.5 * Graphic(Text.Size.Y,temp$))
               Graphic Print temp$
            Case %Chart_2Stack
               temp$ = ThisLabel(BCD(), BC, i, 2, DataTotal(2))
               Graphic Set Pos (BCD(i).rc(1).nLeft + (BarWidth-Graphic(Text.Size.X,temp$))/2, BCD(i).rc(1).Top + BCD(i).rc(2).Top - BCD(i).rc(2).Bottom - 1.5 * Graphic(Text.Size.Y,temp$))
               Graphic Print temp$
            Case %Chart_3Stack
               temp$ = ThisLabel(BCD(), BC, i, 3, DataTotal(3))
               Graphic Set Pos (BCD(i).rc(1).nLeft+(BarWidth-Graphic(Text.Size.X,temp$))/2,  BCD(i).rc(1).Top+BCD(i).rc(2).Top-BCD(i).rc(2).Bottom+BCD(i).rc(3).Top-BCD(i).rc(3).Bottom-1.5 * Graphic(Text.Size.Y,temp$))
               Graphic Print temp$
            Case %Chart_HiLo
               'top value
               temp$ = ThisLabel(BCD(), BC, i, 3, DataTotal(3))
               Graphic Set Pos (BCD(i).rc(1).nLeft+(BarWidth-Graphic(Text.Size.X,temp$))/2, BCD(i).rc(3).Top - 1.5 * Graphic(Text.Size.Y,temp$))
               Graphic Print temp$
               temp$ = ThisLabel(BCD(), BC, i, 2, DataTotal(2))
               Graphic Set Pos (BCD(i).rc(1).nLeft+(BarWidth-Graphic(Text.Size.X,temp$))/2, BCD(i).rc(2).Top + 0.5 * Graphic(Text.Size.Y,temp$))
               Graphic Print temp$
            Case %Chart_3D
               temp$ = ThisLabel(BCD(), BC, i, BC.DataSet, DataTotal(BC.DataSet))
               Graphic Set Pos (BCD(i).rc(1).nLeft + (BarWidth-Graphic(Text.Size.X,temp$))/2, BCD(i).rc(BC.DataSet).Top - BC.ThreeDY - 1.5 * Graphic(Text.Size.Y,temp$))
               Graphic Print temp$
            Case %Chart_Symbols, %Chart_Line
               temp$ = ThisLabel(BCD(), BC, i, BC.DataSet, DataTotal(BC.DataSet))
               Graphic Set Pos (BCD(i).rc(1).nLeft + (BarWidth-Graphic(Text.Size.X,temp$))/2, BCD(i).rc(BC.DataSet).Top - BC.SymbolSize - 1.5 * Graphic(Text.Size.Y,temp$))
               Graphic Print temp$
            Case %Chart_2D
               temp$ = ThisLabel(BCD(), BC, i, BC.DataSet, DataTotal(BC.DataSet))
               Graphic Set Pos (BCD(i).rc(1).nLeft + (BarWidth-Graphic(Text.Size.X,temp$))/2, BCD(i).rc(BC.DataSet).Top - 1.5 * Graphic(Text.Size.Y,temp$))
               Graphic Print temp$
         End Select
      Next i
   End If

   'DrawDataSetTitles
   If BC.ShowDataSetTitles Then
      Graphic Color BC.cAxisValues, -2
      Graphic Set Font BC.axisTitleFont
      Select Case BC.GraphType
         Case %Chart_2D, %Chart_3D, %Chart_Line, %Chart_Symbols
            Graphic Set Pos (gW-BC.RM+20,gH-BC.BM - 3 * Graphic(Text.Size.Y,BC.DataSetTitle(BC.DataSet)))
            Graphic Print BC.DataSetTitle(BC.DataSet)
         Case %Chart_2Line
            Graphic Ellipse (-12+gW-BC.RM+20,2+gH-BC.BM - 3 * Graphic(Text.Size.Y,BC.DataSetTitle(1))) - (-4+gW-BC.RM+20,10+gH-BC.BM - 3 * Graphic(Text.Size.Y,BC.DataSetTitle(1))),%Black, BC.cSymbols(1)
            Graphic Set Pos (gW-BC.RM+20,gH-BC.BM - 3 * Graphic(Text.Size.Y,BC.DataSetTitle(1)))
            Graphic Print BC.DataSetTitle(1)
            Graphic Box (-12+gW-BC.RM+20,2+gH-BC.BM - 2 * Graphic(Text.Size.Y,BC.DataSetTitle(2))) - (-4+gW-BC.RM+20,10+gH-BC.BM - 2 * Graphic(Text.Size.Y,BC.DataSetTitle(2))),,%Black, BC.cSymbols(2)
            Graphic Set Pos (gW-BC.RM+20,gH-BC.BM - 2 * Graphic(Text.Size.Y,BC.DataSetTitle(2)))
            Graphic Print BC.DataSetTitle(2)
         Case %Chart_2Stack
            Graphic Set Pos (gW-BC.RM+20,gH-BC.BM - 3 * Graphic(Text.Size.Y,BC.DataSetTitle(2)))
            Graphic Print BC.DataSetTitle(2)
            Graphic Set Pos (gW-BC.RM+20,gH-BC.BM - 2 * Graphic(Text.Size.Y,BC.DataSetTitle(1)))
            Graphic Print BC.DataSetTitle(1)
         Case %Chart_3Line
            Graphic Ellipse (-12+gW-BC.RM+20,2+gH-BC.BM - 3 * Graphic(Text.Size.Y,BC.DataSetTitle(1))) - (-4+gW-BC.RM+20,10+gH-BC.BM - 3 * Graphic(Text.Size.Y,BC.DataSetTitle(1))),%Black, BC.cSymbols(1)
            Graphic Set Pos (gW-BC.RM+20,gH-BC.BM - 3 * Graphic(Text.Size.Y,BC.DataSetTitle(1)))
            Graphic Print BC.DataSetTitle(1)
            Graphic Box (-12+gW-BC.RM+20,2+gH-BC.BM - 2 * Graphic(Text.Size.Y,BC.DataSetTitle(2))) - (-4+gW-BC.RM+20,10+gH-BC.BM - 2 * Graphic(Text.Size.Y,BC.DataSetTitle(2))),, %Black, BC.cSymbols(2)
            Graphic Set Pos (gW-BC.RM+20,gH-BC.BM - 2 * Graphic(Text.Size.Y,BC.DataSetTitle(2)))
            Graphic Print BC.DataSetTitle(2)
            Graphic Line (-8+gW-BC.RM+20,2+gH-BC.BM - 1 * Graphic(Text.Size.Y,BC.DataSetTitle(3))) - (-12+gW-BC.RM+20,10+gH-BC.BM - 1 * Graphic(Text.Size.Y,BC.DataSetTitle(3))), %Black
            Graphic Line (-8+gW-BC.RM+20,2+gH-BC.BM - 1 * Graphic(Text.Size.Y,BC.DataSetTitle(3))) - (-4+gW-BC.RM+20,10+gH-BC.BM - 1 * Graphic(Text.Size.Y,BC.DataSetTitle(3))), %Black
            Graphic Line (-12+gW-BC.RM+20,10+gH-BC.BM - 1 * Graphic(Text.Size.Y,BC.DataSetTitle(3))) - (-4+gW-BC.RM+20,10+gH-BC.BM - 1 * Graphic(Text.Size.Y,BC.DataSetTitle(3))), %Black
            Graphic Paint (-10+gW-BC.RM+20,8+gH-BC.BM - 1 * Graphic(Text.Size.Y,BC.DataSetTitle(3))), BC.cSymbols(3), %Black
            Graphic Set Pos (gW-BC.RM+20,gH-BC.BM - 1 * Graphic(Text.Size.Y,BC.DataSetTitle(3)))
            Graphic Print BC.DataSetTitle(3)
         Case %Chart_3Stack
            Graphic Set Pos (gW-BC.RM+20,gH-BC.BM - 3 * Graphic(Text.Size.Y,BC.DataSetTitle(3)))
            Graphic Print BC.DataSetTitle(3)
            Graphic Set Pos (gW-BC.RM+20,gH-BC.BM - 2 * Graphic(Text.Size.Y,BC.DataSetTitle(2)))
            Graphic Print BC.DataSetTitle(2)
            Graphic Set Pos (gW-BC.RM+20,gH-BC.BM - 1 * Graphic(Text.Size.Y,BC.DataSetTitle(1)))
            Graphic Print BC.DataSetTitle(1)
         Case %Chart_HiLo
            Graphic Set Pos (gW-BC.RM+20,gH-BC.BM - 3 * Graphic(Text.Size.Y,BC.DataSetTitle(3)))
            Graphic Print BC.DataSetTitle(3)
            Graphic Set Pos (gW-BC.RM+20,gH-BC.BM - 2 * Graphic(Text.Size.Y,BC.DataSetTitle(2)))
            Graphic Print BC.DataSetTitle(2)
      End Select
   End If
   Graphic ReDraw
   BC.LM = tempBCLM : BC.TM = tempBCTM : BC.RM = tempBCRM : BC.BM = tempBCBM

   If BC.SpeedTest Then
      QueryPerformanceCounter qStop
      Dialog Set Text BC.hParent, Format$((qStop-qStart)/qFreq,"###.000") & " seconds"
   End If

End Sub

Sub DrawOneBar(BCD() As ChartData, rc As Rect,BC As ChartSettings, ByVal TheColor As Long, iSelected As Long, oldRC As Rect, Optional RoundFlag As Long)
   Local p As ChartPolyPoints, x,y,w,h,RR,GG,BB,iCount,BorderColor,FadedColor,DarkFadedColor, gH,gW As Long

   Graphic Get Client To gW,gH
   RR = GetRValue(TheColor)
   GG = GetGValue(TheColor)
   BB = GetBValue(TheColor)

   FadedColor     = RGB(Min(255,BC.FadeValue+RR),Min(255,BC.FadeValue+GG),Min(255,BC.FadeValue+BB))
   DarkFadedColor = RGB(Min(255,BC.FadeValue+0.8*RR),Min(255,BC.FadeValue+0.8*GG),Min(255,BC.FadeValue+0.8*BB))

   Select Case BC.BarBorder
      Case 1 : BorderColor = FadedColor
      Case 2 : BorderColor = %Black
      Case 3 : BorderColor = %White
   End Select

   If iSelected Then Graphic Width 3
   Select Case BC.GraphType
      Case %Chart_2D
         If BC.RoundedBar And BC.RoundValue Then
            DrawTombstone rc, BC, BorderColor, FadedColor
         Else
            Graphic Box (rc.nLeft,rc.nTop)-(rc.nRight,rc.nBottom),,BorderColor, FadedColor
         End If
      Case %Chart_2Stack
         If BC.RoundedBar And BC.RoundValue And (RoundFlag = %True) Then
            DrawTombstone rc, BC, BorderColor, FadedColor
         Else
            Graphic Box (rc.nLeft,rc.nTop)-(rc.nRight,rc.nBottom),,BorderColor, FadedColor
         End If
      Case %Chart_3Stack
         If BC.RoundedBar And BC.RoundValue And (RoundFlag = %True) Then
            DrawTombstone rc, BC, BorderColor, FadedColor
         Else
            Graphic Box (rc.nLeft,rc.nTop)-(rc.nRight,rc.nBottom),,BorderColor, FadedColor
         End If
      Case %Chart_HiLo
         Select Case BC.HiLoSymbol
            Case %HiLo_Bar
               Graphic Box (rc.nLeft,rc.nTop)-(rc.nRight,rc.nBottom),IIf(BC.RoundedBar, BC.RoundValue, 0),BorderColor, FadedColor
            Case %HiLo_Beam
               Graphic Width BC.Linethickness
               x = rc.nLeft+(rc.nRight-rc.nLeft)/2
               Graphic Line (x-BC.LineThickness-2,rc.nTop)   - (x+BC.LineThickness+2,rc.nTop),BorderColor
               Graphic Line (x-BC.LineThickness-2,rc.nBottom)- (x+BC.LineThickness+2,rc.nBottom), BorderColor
               Graphic Line (x,rc.nTop)-(x,rc.nBottom),BorderColor
               Graphic Width 1
            Case %HiLo_Dot
               Graphic Width BC.Linethickness
               x = rc.nLeft+(rc.nRight-rc.nLeft)/2
               Graphic Line (x-BC.LineThickness-2,rc.nTop)   - (x+BC.LineThickness+2,rc.nTop),BorderColor
               Graphic Line (x-BC.LineThickness-2,rc.nBottom)- (x+BC.LineThickness+2,rc.nBottom), BorderColor
               Graphic Line (x,rc.nTop)-(x,rc.nBottom),BorderColor
               Graphic Width 1
               Graphic Ellipse (x-BC.SymbolSize, rc.nTop + (rc.nBottom-rc.nTop)/2-BC.SymbolSize) - (x+BC.SymbolSize,rc.nTop + (rc.nBottom-rc.nTop)/2+BC.SymbolSize),BorderColor,BC.cSymbols(BC.DataSet)
         End Select

      Case %Chart_3D
         Graphic Box (rc.nLeft,rc.nTop)-(rc.nRight,rc.nBottom),,BorderColor, FadedColor
         p.count = 6
         p.x1 = rc.nLeft             : p.y1 = rc.nTop
         p.x2 = rc.nLeft+BC.ThreeDX  : p.y2 = rc.nTop-BC.ThreeDY
         p.x3 = rc.nRight+BC.ThreeDX : p.y3 = rc.nTop-BC.ThreeDY
         p.x4 = rc.nRight+BC.ThreeDX : p.y4 = rc.nBottom-BC.ThreeDY
         p.x5 = rc.nRight            : p.y5 = rc.nBottom
         p.x6 = rc.nRight            : p.y6 = rc.nTop
         Graphic Polygon p, BorderColor, DarkFadedColor
         Graphic Line (rc.nRight,rc.nTop)-(rc.nRight+BC.ThreeDX,rc.nTop-BC.ThreeDY),BorderColor

      Case %Chart_Line, %Chart_Symbols, %Chart_2Line, %Chart_3Line
         If BC.GraphType <> %Chart_Symbols Then Graphic Style BC.LineStyle
         Graphic Width BC.LineThickNess
         If BC.SmoothLines Then
            'Bezier curves
            'DrawCurves BCD(), BC, 0.01, 0.5
         ElseIf BC.UseAntiAliasing Then
            If BC.ColorUnder Then
               If (BC.GraphType=%Chart_Line Or BC.GraphType=%Chart_2Line Or BC.GraphType = %Chart_3Line) And oldrc.nTop Then Graphic Box ((oldrc.nLeft + oldrc.nRight)/2,oldrc.nTop) - ((rc.nLeft + rc.nRight)/2,gH-BC.BM-1),, TheColor, TheColor
            Else
               If (BC.GraphType=%Chart_Line Or BC.GraphType=%Chart_2Line Or BC.GraphType = %Chart_3Line) And oldrc.nTop Then GraphicLineAA BC.hGraphicDC, (oldrc.nLeft + oldrc.nRight)/2,oldrc.nTop, (rc.nLeft + rc.nRight)/2,rc.nTop , TheColor
            End If
         Else
            If BC.ColorUnder Then
               If (BC.GraphType=%Chart_Line Or BC.GraphType=%Chart_2Line Or BC.GraphType = %Chart_3Line) And oldrc.nTop Then Graphic Box ((oldrc.nLeft + oldrc.nRight)/2,oldrc.nTop)-((rc.nLeft + rc.nRight)/2,gH-BC.BM-1),, TheColor, TheColor
            Else
               If (BC.GraphType=%Chart_Line Or BC.GraphType=%Chart_2Line Or BC.GraphType = %Chart_3Line) And oldrc.nTop Then Graphic Line ((oldrc.nLeft + oldrc.nRight)/2,oldrc.nTop)-((rc.nLeft + rc.nRight)/2,rc.nTop), TheColor
            End If
         End If
         Graphic Style 0
         Graphic Width BC.SymbolSize
         x = (rc.nLeft + rc.nRight)/2 : y = rc.nTop
         Select Case BC.linesymbol
            Case %Symbol_Point
               Graphic Set Pixel (x,y), TheColor
            Case %Symbol_Circle 'circle (dot)
               Graphic Ellipse (x-BC.SymbolSize-2,y-BC.SymbolSize-2)-(x+BC.SymbolSize+2,y+BC.SymbolSize+2),BorderColor,BC.cSymbols(BC.DataSet)
               If oldRC.nTop Then
                  x = (oldrc.nLeft + oldrc.nRight)/2 : y = oldrc.nTop
                  Graphic Ellipse (x-BC.SymbolSize-2,y-BC.SymbolSize-2)-(x+BC.SymbolSize+2,y+BC.SymbolSize+2),BorderColor,BC.cSymbols(BC.DataSet)
               End If
            Case %Symbol_Triangle
               p.count = 6
               p.x1 = x                    : p.y1 = rc.nTop-BC.SymbolSize-4
               p.x2 = x+BC.SymbolSize+4    : p.y2 = rc.nTop+BC.SymbolSize+4
               p.x3 = x-BC.SymbolSize-4    : p.y3 = rc.nTop+BC.SymbolSize+4
               p.x4 = p.x3 : p.x5 = p.x3 : p.x6 = p.x3 : p.y4 = p.y3 : p.y5 = p.y3 : p.y6 = p.y3
               Graphic Polygon p, BorderColor, BC.cSymbols(BC.DataSet)
               If oldRc.nTop Then
                  x = (oldrc.nLeft + oldrc.nRight)/2 : y = oldrc.nTop
                  p.x1 = x                   : p.y1 = oldrc.nTop-BC.SymbolSize-4
                  p.x2 = x+BC.SymbolSize+4   : p.y2 = oldrc.nTop+BC.SymbolSize+4
                  p.x3 = x-BC.SymbolSize-4   : p.y3 = oldrc.nTop+BC.SymbolSize+4
                  p.x4 = p.x3 : p.x5 = p.x3 : p.x6 = p.x3 : p.y4 = p.y3 : p.y5 = p.y3 : p.y6 = p.y3
                  Graphic Polygon p, BorderColor, BC.cSymbols(BC.DataSet)
               End If
            Case %Symbol_Square
               Graphic Box (x-BC.SymbolSize-2,y-BC.SymbolSize-2)-(x+BC.SymbolSize+2,y+BC.SymbolSize+2),,BorderColor, BC.cSymbols(BC.DataSet)
               If oldrc.nTop Then
                  x = (oldrc.nLeft + oldrc.nRight)/2 : y = oldrc.nTop
                  Graphic Box (x-BC.SymbolSize-2,y-BC.SymbolSize-2)-(x+BC.SymbolSize+2,y+BC.SymbolSize+2),,BorderColor, BC.cSymbols(BC.DataSet)
               End If
         End Select
         Graphic Width 1
   End Select
   If iSelected Then Graphic Width 1

   If BC.GraphType = %Chart_2D Or BC.GraphType = %Chart_3D Or BC.GraphType = %Chart_2Stack Or BC.GraphType = %Chart_3D Or BC.GraphType = %Chart_HiLo Then
      Select Case BC.BarGradientType
         Case %Gradient_DarkBottomToTop  'darkcolor bottom to color on top
            h = rc.nBottom - rc.nTop - 2
            For y = rc.nBottom-1 To rc.nTop+1 Step -1
               Graphic Line (rc.nLeft+1,y)-(rc.nRight-1,y), RGB(Min(255,BC.FadeValue+RR*iCount/h), Min(255,BC.FadeValue+GG*iCount/h), Min(255,BC.FadeValue+ BB*iCount/h))
               Incr iCount
            Next y
         Case %Gradient_LightCenterToDarkSide  'lightcolor center, fade to color on each side
            w = (rc.nRight - rc.nLeft - 2)/2
            For x = rc.nLeft+1 To (rc.nLeft+rc.nRight+2)/2
               Graphic Line (x,rc.nTop+1)-(x,rc.nBottom-1), RGB(Min(255,BC.FadeValue+RR+(240-RR)*iCount/w),Min(255,BC.FadeValue+GG+(240-GG)*iCount/w),Min(255,BC.FadeValue+BB+(240-BB)*iCount/w))
               Incr iCount
            Next x
            iCount = 0
            For x = rc.nRight-1 To (rc.nLeft+rc.nRight+2)/2 Step -1
               Graphic Line (x,rc.nTop+1)-(x,rc.nBottom-1), RGB(Min(255,BC.FadeValue+RR+(240-RR)*iCount/w),Min(255,BC.FadeValue+GG+(240-GG)*iCount/w),Min(255,BC.FadeValue+BB+(240-BB)*iCount/w))
               Incr iCount
            Next x
            iCount = 0
         Case %Gradient_ColorCenterToBlackSide
            w = (rc.nRight - rc.nLeft - 2)/2
            For x = rc.nLeft+1 To (rc.nLeft+rc.nRight+2)/2
               Graphic Line (x,rc.nTop+1)-(x,rc.nBottom-1), RGB(Min(255,BC.FadeValue+RR*iCount/w),Min(255,BC.FadeValue+GG*iCount/w),Min(255,BC.FadeValue+BB*iCount/w))
               Incr iCount
            Next x
            iCount = 0
            For x = rc.nRight-1 To (rc.nLeft+rc.nRight+2)/2 Step -1
               Graphic Line (x,rc.nTop+1)-(x,rc.nBottom-1), RGB(Min(255,BC.FadeValue+RR*iCount/w),Min(255,BC.FadeValue+GG*iCount/w),Min(255,BC.FadeValue+BB*iCount/w))
               Incr iCount
            Next x
            iCount = 0
      End Select
   End If

   If BC.BarGradientType = %Gradient_Background Then 'color bottom to white on top (used for gradient background
      h = rc.nBottom - 2
      For y = rc.nBottom To rc.nTop Step -1
         If BC.FadeBG Then
            Graphic Line (rc.nLeft,y)-(rc.nRight,y), RGB(Min(255,BC.FadeValue+RR+(240-RR)*iCount/h),Min(255,BC.FadeValue+GG+(240-GG)*iCount/h),Min(255,BC.FadeValue+BB+(240-BB)*iCount/h))
         Else
            Graphic Line (rc.nLeft,y)-(rc.nRight,y), RGB(RR+(240-RR)*iCount/h,GG+(240-GG)*iCount/h,BB+(240-BB)*iCount/h)
         End If
         Incr iCount
      Next y
   End If

   oldrc = rc


End Sub

Sub DrawTombStone(ByVal rc As Rect, BC As ChartSettings, BorderColor As Long, FadedColor As Long)
   Local gW,gH,w,r,h As Long
   If IsRectEmpty(rc) Then Exit Sub
   Graphic Get Client To gW,gH
   w = rc.nRight - rc.nLeft + 1
   h = rc.nBottom - rc.nTop + 1
   R =  w * BC.RoundValue / 200
   If R > h Then R = h
   Graphic Pie (rc.nLeft,rc.nTop)-(rc.nRight+1,rc.nTop+2*(R-1)+1),0.001!,3.14059,BorderColor, FadedColor
   If (rc.nTop + R < rc.nBottom) Then
      Graphic Box (rc.nLeft,rc.nTop+R)-(rc.nRight,rc.nBottom),,BorderColor, Fadedcolor
      Graphic Line (rc.nLeft+1,rc.nTop+R)-(rc.nRight-1,rc.nTop+R), FadedColor
      Graphic Line (rc.nLeft+1,rc.nTop+R-1)-(rc.nRight-1,rc.nTop+R-1), FadedColor
   End If
End Sub

Sub GraphicLineAA(hdc As Long, x1 As Long, y1 As Long, x2 As Long, y2 As Long, AColor As Long)
    Dim deltax As Integer, deltay As Integer, loopc As Integer
    Dim start As Integer, finish As Integer
    Dim dx As Single, dy As Single, dydx As Single
    Dim LR As Byte, LG As Byte, LB As Byte

    deltax = Abs(x2 - x1) ' Calculate deltax and deltay for initialisation
    deltay = Abs(y2 - y1)
    If (deltax <> 0) And (deltay <> 0) Then  ' it is not a horizontal or a vertical line
        LR = (AColor And &HFF&)
        LG = (AColor And &HFF00&) / &H100&
        LB = (AColor And &HFF0000) / &H10000
        If deltax > deltay Then  ' horizontal or vertical
            If y2 > y1 Then ' determine rise and run
                dydx = -(deltay / deltax)
            Else
                dydx = deltay / deltax
            End If
            If x2 < x1 Then
                start = x2 ' right to left
                finish = x1
                dy = y2
            Else
                start = x1 ' left to right
                finish = x2
                dy = y1
                dydx = -dydx ' inverse slope
            End If
            For loopc = start To finish
                AlphaBlendPixel hdc, loopc, CInt(dy - 0.5), LR, LG, LB, _
                1 - FracPart(dy)
                AlphaBlendPixel hdc, loopc, CInt(dy - 0.5) + 1, LR, LG, _
                LB, FracPart(dy)
                dy = dy + dydx ' next point
            Next loopc
        Else
            If x2 > x1 Then ' determine rise and run
                dydx = -(deltax / deltay)
            Else
                dydx = deltax / deltay
            End If
            If y2 < y1 Then
                start = y2 ' right to left
                finish = y1
                dx = x2
            Else
                start = y1 ' left to right
                finish = y2
                dx = x1
                dydx = -dydx ' inverse slope
            End If
            For loopc = start To finish
                AlphaBlendPixel hdc, CInt(dx - 0.5), loopc, LR, LG, LB, _
                1 - FracPart(dx)
                AlphaBlendPixel hdc, CInt(dx - 0.5) + 1, loopc, LR, LG, _
                LB, FracPart(dx)
                dx = dx + dydx ' next point
            Next loopc
        End If
    Else
       Graphic Set Pos (x1,y1)
       Graphic Line (x1,y1)-(x2,y2), AColor
    End If
End Sub

' blend a pixel with the current colour and a specified colour
Sub AlphaBlendPixel(ByVal hdc As Long, ByVal x As Integer, _
                    ByVal y As Integer, ByVal R As Byte, ByVal g As Byte, ByVal b As Byte, _
                    ByVal ARatio As Double)
    Dim LMinusRatio As Double
    Dim nr As Byte, ng As Byte, nb As Byte
    Dim dstc As Long, dr As Byte, dg As Byte, Ddb As Byte

    LMinusRatio = 1 - ARatio
    dstc = GetPixel(hdc, x, y)
    dr = (dstc And &HFF&)
    dg = (dstc And &HFF00&) / &H100&
    Ddb = (dstc And &HFF0000) / &H10000

    nb = Round(b * ARatio + Ddb * LMinusRatio, 0)
    ng = Round(g * ARatio + dg * LMinusRatio, 0)
    nr = Round(R * ARatio + dr * LMinusRatio, 0)

    Graphic Set Pixel (x, y), RGB(nr, ng, nb)
End Sub

' Returns the fractional part of a double
Function FracPart(ByVal a As Double) As Double
    Dim b As Double
    b = CLng(a - 0.5)
    FracPart = a - b
End Function

Sub DrawPieChart(BCD() As ChartData, BC As ChartSettings, PieChartPos As Long, PieChartCount As Long, EraseChart As Long, ThisDataSet As Long, PieRedraw As Long)
   Local j,x,y,x0,y0,distance As Long, temp$, RC As Rect, BMP$
   Local r,w,h,tW,tH,iCount,PieTotal,rHorz,rVert As Long, tn,theta, ArcRotate, ArcStart, ArcEnd, ThisArc,ca As Single

   Local i As Long
   Local gW,gH,bgW,bgH As Long
   Local qFreq, qStart, qStop As Quad

   If BC.SpeedTest Then QueryPerformanceFrequency qFreq : QueryPerformanceCounter qStart

   'Clear the Graphic control
   Graphic Attach BC.hGraphic, 0, ReDraw
   If EraseChart Then Graphic Clear BC.cBG
   Graphic Get Client To gW,gH
   Graphic Width 1
   Graphic Set Overlap

   'Get various reusable values
   For i = BC.XMin To BC.XMax
      BCD(i).ArcStart(ThisDataSet) = 0
      BCD(i).ArcEnd(ThisDataSet)   = 0
      PieTotal += BCD(i).v(ThisDataSet)
      BCD(i).RR = GetRValue(BCD(i).altColor(ThisDataSet))
      BCD(i).GG = GetGValue(BCD(i).altColor(ThisDataSet))
      BCD(i).BB = GetBValue(BCD(i).altColor(ThisDataSet))
      BCD(i).FadedColor     = RGB(Min(255,BC.FadeValue+BCD(i).RR),Min(255,BC.FadeValue+BCD(i).GG),Min(255,BC.FadeValue+BCD(i).BB))
      BCD(i).DarkFadedColor = RGB(Min(255,BC.FadeValue+0.8*BCD(i).RR),Min(255,BC.FadeValue+0.8*BCD(i).GG),Min(255,BC.FadeValue+0.8*BCD(i).BB))
      BCD(i).BorderColor    = Choose(BC.BarBorder, BCD(i).FadedColor, %Black, %White)
   Next i

   'Set pie enclosing rectangle
   w = (gW-BC.LM-BC.RM)/PieChartCount        'width of area available for pie
   h = (gH-BC.TM-BC.BM)                      'height of area available for pie
   x = BC.LM + (PieChartPos - 1) * w  + w/2  'center of available area   PieChartPos is 1,2,3
   y = BC.TM + h/2                           'center of available area
   If BC.PieCircle Then w = Min(w,h) * 0.9 : h = w   'use smallest w or h as circle diameter
   RC.nLeft   = x - w/2 * BC.PieRadius / 100  'Resize pie according to the PieRadis (% of available space
   RC.nRight  = x + w/2 * BC.PieRadius / 100  'Resize pie according to the PieRadis (% of available space
   RC.nTop    = y - h/2 * BC.PieRadius / 100  'Resize pie according to the PieRadis (% of available space
   RC.nBottom = y + h/2 * BC.PieRadius / 100  'Resize pie according to the PieRadis (% of available space
   For i = BC.XMin To BC.XMax : BCD(i).rc(ThisDataSet) = RC : Next i

   'Set pie radii  ra/rb
   rHorz = (rc.nRight  - rc.nLeft)/2   'ra = x-radius
   rVert = (rc.nBottom - rc.nTop)/2    'rb = y-radius
   x0 = (rc.nRight  + rc.nLeft)/2   'center of radius x-value
   y0 = (rc.nTop    + rc.nBottom)/2 'center of radius y-value

   'Draw Background - gradient or image
   If BC.ShowBGImage And (BC.GraphType = %Chart_Pie Or (BC.GraphType = %Chart_2Pie And ThisDataSet=1) Or (BC.GraphType = %Chart_3Pie And ThisDataSet=1)) Then
       If BC.BGImageFit Then
         Graphic Attach BC.hBGImage, 0
         Graphic Get Canvas To bgW, bgH
         Graphic Attach BC.hGraphic, 0, ReDraw
         Graphic Stretch BC.hBGImage, 0, (0,0)-(bgW-1,bgH-1) To (0,0)-(gW-1,gH-1), %Mix_CopySrc, %HalfTone
      Else
         Graphic Copy BC.hBGImage, 0
      End If
   ElseIf BC.GradientBG Then
      If EraseChart Then
         h = RC.nBottom - 2
         For y = gH-1 To 0 Step -1
            If BC.FadeBG Then
               Graphic Line (0,y)-(gW-1,y), _
               RGB(Min(255,BC.FadeValue+GetRValue(BC.cBG)+(240-GetRValue(BC.cBG))*iCount/h),Min(255,BC.FadeValue+GetGValue(BC.cBG)+(240-GetGValue(BC.cBG))*iCount/h),Min(255,BC.FadeValue+GetBValue(BC.cBG)+(240-GetBValue(BC.cBG))*iCount/h))
            Else
               Graphic Line (0,y)-(gW-1,y), RGB(GetRValue(BC.cBG)+(240-GetRValue(BC.cBG))*iCount/h,GetGValue(BC.cBG)+(240-GetGValue(BC.cBG))*iCount/h,GetBValue(BC.cBG)+(240-GetBValue(BC.cBG))*iCount/h)
            End If
            Incr iCount
         Next y
      End If
   End If

   'Draw Instructions
   If BC.Instructions Then
      Graphic Set Font BC.InstructFont
      Graphic Width 1
      Graphic Style 2
      Graphic Box (0,0)-(20,20),,%Red, -2         'top left
      Graphic Box (gW-1,0)-(gW-21,20),,%Red, -2     'top right
      Graphic Box (0,gH-1)-(20,gH-21),,%Red, -2     'bottom left
      Graphic Box (gW-1,gH-1)-(gW-21,gH-21),,%Red, -2 'bottom right
      Graphic Style 0
      Graphic Width BC.LineThickness

      Graphic Set Font BC.axisValueFont
      Graphic Color BC.cTitle, -2  'BC.cBG
      'upper left
      Graphic Set Pos (25,10) : Graphic Print "Clk - Erase last symbol, DblClk - Erase all"
      'upper right
      temp$ = "DblClk - Remove Selections"
      Graphic Set Pos (gW - 25 - Graphic(Text.Size.X,temp$),10) : Graphic Print temp$
      'lower left
      Graphic Set Pos (25, gH - 2*Graphic(Text.Size.X,"C")) : Graphic Print "DblClk - Settings Dialog Repositioned"
      'lower right
      Graphic Set Pos (gW - 25 - Graphic(Text.Size.X,"DblClk - Settings"), gH - 2*Graphic(Text.Size.X,"C")) : Graphic Print "DblClk - Settings"
      'midleft
      Graphic Set Pos (10, gH/2 - 30)                              : Graphic Print "DblClk - Stamp"
      Graphic Set Pos (10, gH/2 - 30 + Graphic(Text.Size.Y,"C"))   : Graphic Print "RClick Bar - Select"
      Graphic Set Pos (10, gH/2 - 30 + 2*Graphic(Text.Size.Y,"C")) : Graphic Print "RClick - Settings"
   End If

   'Draw Top Title
   Graphic Color BC.cTitle, -2  'BC.cBG
   If BC.ShowMainTitle Then
      Graphic Set Font BC.TitleFont
      BC.TM = Graphic(Text.Size.Y,BC.Title) * 2
      Select Case BC.MainTitleLoc
         Case %MainTitle_Left   : Graphic Set Pos (BC.LM,BC.TM-1.5*Graphic(Text.Size.Y,BC.Title))
         Case %MainTitle_Center : Graphic Set Pos (BC.LM + (gW-BC.LM-BC.RM-Graphic(Text.Size.X,BC.Title))/2, BC.TM - 1.5*Graphic(Text.Size.Y,BC.Title))
         Case %MainTitle_Right  : Graphic Set Pos (gW - BC.RM - Graphic(Text.Size.X,BC.Title), BC.TM - 1.5*Graphic(Text.Size.Y,BC.Title))
      End Select
      Graphic Print BC.Title
   End If

   'Show Margins
   If BC.ShowMargins Then
      Graphic Color %Red
      Graphic Style 2
      Graphic Line (BC.LM,0)-(BC.LM,gH)
      Graphic Line (0,BC.TM)-(gW,BC.TM)
      Graphic Line (gW-BC.RM,0)-(gW-BC.RM,gH)
      Graphic Line (0,gH-BC.BM)-(gW,gH-BC.BM)
      Graphic Box (RC.nLeft,RC.nTop)-(RC.nRight,RC.nBottom),,%Red
      Graphic Style 0
   End If

   'Draw Pie Sections
   ArcRotate = BC.PieRotate * 0.017453   'BC.PieRotate is in degrees.  ArcXXX values are in radians
   Graphic Width BC.LineThickness
   If BC.Pie3D And (BC.PieCircle = 0) And rVert/rHorz < 0.9 Then
      'draw the 3D bottom parts of the pie - also calculates the .arcStart and .artEnd values
      BC.Pie3DThickness = 0.1 * (RC.nBottom - RC.nTop)
      For j = BC.Pie3DThickness-1 To 1 Step -1
         'Pies in 3D stack
         ArcStart = 0 : ArcEnd = 0
         For i = BC.XMin To BC.XMax
            'If BCD(i).Selected(ThisDataSet) Then Graphic Width BC.LineThickness + BC.PieHighLightSelected * 3 Else Graphic Width BC.LineThickness
            ArcEnd += BCD(i).v(ThisDataSet)/PieTotal * 6.28318
            Graphic Pie (RC.nLeft,RC.nTop+j)-(RC.nRight,RC.nBottom+j), ArcRotate + ArcStart, ArcRotate + ArcEnd, BCD(i).FadedColor, BCD(i).FadedColor
            BCD(i).ArcStart(ThisDataSet) = ArcStart + ArcRotate
            BCD(i).ArcEnd(ThisDataSet) = ArcEnd + ArcRotate
            ArcStart = ArcEnd
         Next i
      Next j
      'draw the vertical lines in the 3D edge
      Graphic Width BC.LineThickness
      For i = BC.XMin To BC.XMax
         'If BCD(i).Selected(ThisDataSet) Then Graphic Width BC.LineThickness + BC.PieHighLightSelected * 3
         tn = Tan(-BCD(i).ArcStart(ThisDataSet))
         x = rVert * rHorz      / ((rVert*rVert + rHorz*rHorz*tn*tn)^0.5)
         y = rVert * rHorz * tn / ((rVert*rVert + rHorz*rHorz*tn*tn)^0.5)
         If BCD(i).ArcStart(ThisDataSet) Mod 6.28318 > 3.14159/2 And BCD(i).ArcStart(ThisDataSet) Mod 6.28318 < 1.5*3.14159 Then x = -1 * x : y = -1 * y
         x = x0 + x
         y = y0 + y
         Graphic Line (x,y)-(x,y+BC.Pie3DThickness-1), BCD(i).BorderColor
      Next i
      'Graphic Width BC.LineThickness
      Graphic Line (x0+rHorz,y0)-(x0+rHorz,y0+BC.Pie3DThickness), BCD(1).BorderColor
      Graphic Line (x0-rHorz,y0)-(x0-rHorz,y0+BC.Pie3DThickness), BCD(1).BorderColor
      Graphic Arc  (RC.nLeft,RC.nTop+BC.Pie3DThickness)-(RC.nRight,RC.nBottom+BC.Pie3DThickness), 3.14159, 6.28318, BCD(1).BorderColor

      'draw the 3D top of the pie
      For i = BC.XMin To BC.XMax
         If BCD(i).Selected(ThisDataSet) Then Graphic Width BC.LineThickness + BC.PieHighLightSelected * 3  Else Graphic Width BC.LineThickness
         Graphic Pie (RC.nLeft,RC.nTop)-(RC.nRight,RC.nBottom), BCD(i).ArcStart(ThisDataSet), BCD(i).ArcEnd(ThisDataSet), BCD(i).BorderColor, BCD(i).FadedColor
      Next i

   Else
      For i = BC.XMin To BC.XMax
         If BCD(i).Selected(ThisDataSet) Then Graphic Width BC.LineThickness + BC.PieHighLightSelected * 3
         ArcEnd += BCD(i).v(ThisDataSet)/PieTotal * 6.28318
         BCD(i).ArcStart(ThisDataSet) = ArcStart + ArcRotate
         BCD(i).ArcEnd(ThisDataSet) = ArcEnd + ArcRotate
         If BC.PieExplode Then
            ca = (BCD(i).ArcStart(ThisDataSet)+BCD(i).ArcEnd(ThisDataSet))/2 + ArcRotate
            x = BC.PieExplodeDistance * Sin(ca+1.57075)
            y = BC.PieExplodeDistance * Cos(ca+1.57075)
            Graphic Pie (RC.nLeft+x,RC.nTop+y)-(RC.nRight+x,RC.nBottom+y), ArcRotate + BCD(i).ArcStart(ThisDataSet), ArcRotate + BCD(i).ArcEnd(ThisDataSet), BCD(i).BorderColor, BCD(i).FadedColor
         ElseIf BCD(i).Selected(ThisDataSet) And BC.PieEject Then
            Graphic Width BC.LineThickness + BC.PieHighlightSelected * 3
            ca = (BCD(i).ArcStart(ThisDataSet)+BCD(i).ArcEnd(ThisDataSet))/2 '+ ArcRotate
            x = BC.PieExplodeDistance * Sin(ca+1.57075)
            y = BC.PieExplodeDistance * Cos(ca+1.57075)
            Graphic Pie (RC.nLeft+x,RC.nTop+y)-(RC.nRight+x,RC.nBottom+y), BCD(i).ArcStart(ThisDataSet), BCD(i).ArcEnd(ThisDataSet), BCD(i).BorderColor, BCD(i).FadedColor
         ElseIf BCD(i).Selected(ThisDataSet) = 0 And BC.PieHideUnselected Then
            'do not show
         Else
            Graphic Pie (RC.nLeft,RC.nTop)-(RC.nRight,RC.nBottom), BCD(i).ArcStart(ThisDataSet), BCD(i).ArcEnd(ThisDataSet), BCD(i).BorderColor, BCD(i).FadedColor
         End If
         ArcStart = ArcEnd
         Graphic Width BC.LineThickness
      Next i
   End If

'temp$ = ""
'For i = BC.XMin to BC.XMax
'   temp$ += str$(BCD(i).v(ThisDataSet)/PieTotal * 6.28318) + $Tab + Str$(BCD(i).ArcStart(ThisDataSet)) + $TAB + Str$(BCD(i).ArcEnd(ThisDataSet)) + $crlf
'next i
'? Temp$

   'Draw Gradient on top of PIE
   If BC.PieGradient Then
      Graphic Get Bits To bmp$
      ReDim MyColors(0 To gW-1, 0 To gH-1) As Long At StrPtr(bmp$) + 8
      For i = RC.nLeft To RC.nRight
         For j = RC.nTop To RC.nBottom
            theta = Atn((j-y0)/(i-x0))
            r = (rHorz*rVert) / (rHorz*rHorz*Sin(theta)*Sin(theta) + rVert*rVert*Cos(theta)*Cos(theta))^0.5
            distance = ((i-x0)*(i-x0) + (j-y0)*(j-y0)) ^ 0.5
            If distance > r Then Iterate For
            MyColors(i,j) = RGB( Min(255,(r-distance)/r*BC.PieGradientValue+GetRValue(MyColors(i,j))), _
                                 Min(255,(r-distance)/r*BC.PieGradientValue+GetGValue(MyColors(i,j))), _
                                 Min(255,(r-distance)/r*BC.PieGradientValue+GetBValue(MyColors(i,j))) )
         Next j
      Next i
      Graphic Set Bits bmp$
   End If

   'Draw Pie %'s
   If BC.PiePerCent Then
      Graphic Color BC.cAxisValues
      Graphic Set Font BC.AxisValueFont
      For i = BC.Xmin To BC.Xmax
         If BC.PieHideUnselected And BCD(i).Selected(ThisDataSet)=0 Then Iterate For
         temp$ = Format$(BCD(i).v(ThisDataSet) / PieTotal * 100, "#0.0") + "%"
         Graphic Text Size temp$ To tw, th
         theta = (BCD(i).arcEnd(ThisDataSet) + BCD(i).arcStart(ThisDataSet))/2
         r = (rHorz*rVert) / (rHorz*rHorz*Sin(theta)*Sin(theta) + rVert*rVert*Cos(theta)*Cos(theta))^0.5
         x = x0 - tw/2 +  0.65 * r * Cos((BCD(i).arcEnd(ThisDataSet) + BCD(i).arcStart(ThisDataSet))/2)
         y = y0 - th/2 -  0.65 * r * Sin((BCD(i).arcEnd(ThisDataSet) + BCD(i).arcStart(ThisDataSet))/2)
         Graphic Set Pos(x, y)
         Graphic Print temp$
      Next i
   End If

   'Draw Pie Labels
   temp$ = ""
   If BC.ShowBarLabel Then
      Graphic Color BC.cTitle
      Graphic Set Font BC.LabelFont
      For i = BC.Xmin To BC.Xmax
         If BC.PieHideUnselected And BCD(i).Selected(ThisDataSet)=0 Then Iterate For
         Select Case BC.LabelType
            Case %Label_Value    : temp$ = Format$(BCD(i).v(ThisDataSet), "###,###,##0")
            Case %Label_Label    : temp$ = BCD(i).label(ThisDataSet)
            Case %Label_PerCent  : temp$ = Format$(BCD(i).v(ThisDataSet) / PieTotal * 100, "#0.0") + "%"
            Case %Label_AltXText : temp$ = BCD(i).altXText(ThisDataSet)
         End Select
         Graphic Text Size temp$ To tw, th
         theta = (BCD(i).arcEnd(ThisDataSet) + BCD(i).arcStart(ThisDataSet))/2

         If BC.PieExplode Then
            j = BC.PieExplodeDistance
         ElseIf BC.PieEject And BCD(i).Selected(ThisDataSet) Then
            j = BC.PieExplodeDistance
         Else
            j = 0
         End If
         If BC.PieCircle=0 And BC.Pie3D And (BCD(i).ArcStart(ThisDataSet) > 3.14159) Then j += BC.Pie3DThickness

         r = (rHorz*rVert) / (rHorz*rHorz*Sin(theta)*Sin(theta) + rVert*rVert*Cos(theta)*Cos(theta))^0.5 + j
         Select Case theta
            Case < 3.14159/2
               x = x0 +  1.1 * r * Cos(Theta)
               y = y0 - th/2 -  1.1 * r * Sin(Theta)
            Case < 3.14159
               x = x0 - tw +  1.1 * r * Cos(Theta)
               y = y0 - th/2 -  1.1 * r * Sin(Theta)
            Case < 3 * 3.14159/2
               x = x0 - tw +  1.1 * r * Cos(Theta)
               y = y0 -  1.1 * r * Sin(Theta)
            Case Else
               x = x0 +  1.1 * r * Cos(Theta)
               y = y0 -  1.1 * r * Sin(Theta)
         End Select
         Graphic Set Pos(x, y)
         Graphic Print temp$
      Next i
   End If

   'Show Legend
   Graphic Width 2
   If BC.PieLegend Then
      iCount = 0 : x = 0
      Graphic Color BC.cAxisValues, -2
      Graphic Set Font BC.axisTitleFont
      Graphic Text Size "8" To w,h

      y = ((RC.nBottom-RC.nTop) - (BC.XMax-BC.XMin+1)*h)/2
      For i = BC.Xmin To BC.XMax
         x0 = RC.nRight + 40
         y0 = RC.nTop + iCount * h + y
         Graphic Box (x0,y0)-(x0+w,y0+w),,BCD(i).FadedColor, BCD(i).FadedColor
         Graphic Set Pos (x0+2*w,y0-w/2)
         Graphic Print BCD(i).label(ThisDataSet)
         Incr iCount
      Next i
   End If

   'DrawDataSetTitles
   If BC.ShowDataSetTitles Then
      Graphic Color BC.cAxisValues, -2
      Graphic Set Font BC.axisTitleFont
      Graphic Set Pos (RC.nLeft + (Rc.nRight - Rc.nLeft)/2 - Graphic(Text.Size.X,BC.DataSetTitle(ThisDataSet))/2, gH - BC.BM)
      Graphic Print BC.DataSetTitle(ThisDataSet)
   End If

   If PieRedraw Then Graphic ReDraw

   If BC.SpeedTest Then
      QueryPerformanceCounter qStop
      Dialog Set Text BC.hParent, Format$((qStop-qStart)/qFreq,"###.000") & " seconds"
   End If

End Sub

Sub DrawBezier(ByVal dt As Single, pt0 As Point, pt1 As Point, pt2 As Point, pt3 As Point, iColor As Long)
    Local t,x0,y0,x1,y1 As Single
    t = 0
    x1 = pt0.x * (1 - t) ^ 3  + pt1.x * 3 * t * (1 - t) ^ 2 + pt2.x * 3 * t ^ 2 * (1 - t) + pt3.x * t ^ 3
    y1 = pt0.y * (1 - t) ^ 3  + pt1.y * 3 * t * (1 - t) ^ 2 + pt2.y * 3 * t ^ 2 * (1 - t) + pt3.y * t ^ 3
    t = t + dt
    Do While t < 1
        x0 = x1 : y0 = y1
        x1 = pt0.x * (1 - t) ^ 3  + pt1.x * 3 * t * (1 - t) ^ 2 + pt2.x * 3 * t ^ 2 * (1 - t) + pt3.x * t ^ 3
        y1 = pt0.y * (1 - t) ^ 3  + pt1.y * 3 * t * (1 - t) ^ 2 + pt2.y * 3 * t ^ 2 * (1 - t) + pt3.y * t ^ 3
        Graphic Line  (x0, y0)-(x1, y1), iColor
        t = t + dt
    Loop
    ' Connect to the final point.
    t = 1
    x0 = x1 : y0 = y1 : x1 = pt3.x : y1 = pt3.y
    Graphic Line (x0, y0)-(x1, y1), %Blue
End Sub

Sub DrawCurves(BCD() As ChartData, BC As ChartSettings, ByVal dt As Single, ByVal tension As Single, ThisDataSet As Long, iColor As Long)
   Local control_scale As Single, i As Integer
   Local pt,pt_before, pt_after, pt_after2, Di, DiPlus1, p1, p2, p3, p4 As Point

   'Graphic Clear
    control_scale = CSng(tension / 0.5 * 0.175)
    For i = BC.Xmin To BC.XMax - 1
        If BC.XMin = BC.XMin Then
           pt_before = BCD(i).pt(ThisDataSet)
        Else
           pt_before = BCD(i-1).pt(ThisDataSet)
        End If
        pt = BCD(i).pt(ThisDataSet)
        pt_after = BCD(i+1).pt(ThisDataSet)
        pt_after2 = BCD(Min(i + 2, BC.XMax)).pt(ThisDataSet)
        p1 = BCD(i).pt(ThisDataSet)
        p4 = BCD(i+1).pt(ThisDataSet)

        Di.X = pt_after.X - pt_before.X
        Di.Y = pt_after.Y - pt_before.Y
        p2.X = pt.X + control_scale * Di.X
        p2.Y = pt.Y + control_scale * Di.Y

        DiPlus1.X = pt_after2.X - BCD(i).pt(ThisDataSet).x
        DiPlus1.Y = pt_after2.Y - BCD(i).pt(ThisDataSet).y
        p3.X = pt_after.X - control_scale * DiPlus1.X
        p3.Y = pt_after.Y - control_scale * DiPlus1.Y

        DrawBezier dt, p1, p2, p3, p4, iColor
    Next i
End Sub

Function ThisLabel(BCD() As ChartData, BC As ChartSettings, iPos As Long, ThisDataSet As Long, DataTotal As Long) As String
   Select Case BC.LabelType
      Case %Label_Label    : Function = BCD(iPos).Label(ThisDataSet)
      Case %Label_Value    : Function = Format$(BCD(iPos).v(ThisDataSet),"###,###,##0")
      Case %Label_PerCent  : Function = Format$(BCD(iPos).v(ThisDataSet)/DataTotal*100,"##0.0") + "%"
      Case %Label_AltXText : Function = BCD(iPos).AltXText(ThisDataSet)
   End Select
End Function

Function ArcLength(rc As Rect,theta1 As Single, theta2 As Single, Steps As Long) As Single
   Local Result,x,y,L,theta,tn,div,x0,y0,rVert,rHorz,xOld,yOld As Single, i As Long
   'useful values
   div = (theta2 - theta1) / Steps
   rVert = (rc.nBottom - rc.nTop) / 2 : rHorz = (rc.nRight - rc.nLeft) / 2
   x0 = (rc.nRight + rc.nLeft) / 2    : y0 = (rc.nTop + rc.nBottom) / 2
   'approximate arc length by adding chords
   For i = 0 To Steps
      theta = theta1 + i * div
      tn = Tan(-theta)
      x = rVert * rHorz      / ((rVert*rVert + rHorz*rHorz*tn*tn)^0.5)
      y = rVert * rHorz * tn / ((rVert*rVert + rHorz*rHorz*tn*tn)^0.5)
      If theta > 3.14159/2 And theta < 1.5*3.14159 Then x = -1 * x : y = -1 * y
      x = x0 + x : y = y0 + y
      If i Then
         L = ((x-xOld)*(x-xOld) + (y-yOld)*(y-yOld)) ^0.5
         Result += L
      End If
      xOld = x : yOld = y
      Function = Result
   Next i
End Function
